package org.example;

import org.openqa.selenium.*;
import org.openqa.selenium.support.ui.ExpectedConditions;
import org.openqa.selenium.support.ui.WebDriverWait;

import java.time.Duration;

public class GamePage {
    private WebDriver driver;
    private WebDriverWait wait;

    public GamePage(WebDriver driver) {
        this.driver = driver;
        this.wait = new WebDriverWait(driver, Duration.ofSeconds(10));
    }


    public void searchGame(String query) {
        WebElement searchBox = wait.until(ExpectedConditions.visibilityOfElementLocated(By.name("q")));
        searchBox.sendKeys(query);
        searchBox.sendKeys(Keys.RETURN);
        wait.until(ExpectedConditions.visibilityOfElementLocated(By.cssSelector(".g .rc .r a")));
    }

    // Выбираем "Играть с другом"
    public void selectPlayWithFriend() {
        WebElement playButton1 =wait.until(ExpectedConditions.visibilityOfElementLocated(By.xpath("/html/body/div[3]/div/div[13]/div[1]/div[2]/div[2]/div/div/div[1]/div/block-component/div/div[1]/div[1]/div/div/div[1]/div/div/div/div/div[1]/g-dropdown-menu/g-popup/div[1]")));
        WebElement playButton = wait.until(ExpectedConditions.visibilityOfElementLocated(By.xpath("/html/body/div[3]/div/div[8]/div/g-menu/g-menu-item[4]/div")));
        playButton.click();
        playButton1.click();
    }


    public boolean isCellAvailable(int row, int col) {
        String xpath = String.format("//tr[%d]/td[%d]", row, col);
        try {
            WebElement cell = wait.until(ExpectedConditions.elementToBeClickable(By.xpath(xpath)));
            return cell.getText().isEmpty();
        } catch (Exception e) {
            return false;
        }
    }


    public void makeMove(int row, int col) {
        String xpath = String.format("//tr[%d]/td[%d]", row, col);
        WebElement cell = wait.until(ExpectedConditions.elementToBeClickable(By.xpath(xpath)));
        cell.click();
    }


    public boolean checkWinner() {
        String[][] board = new String[3][3];
        for (int i = 1; i <= 3; i++) {
            for (int j = 1; j <= 3; j++) {
                String xpath = String.format("//tr[%d]/td[%d]", i, j);
                board[i - 1][j - 1] = driver.findElement(By.xpath(xpath)).getText();
            }
        }


        for (int i = 0; i < 3; i++) {
            if ((board[i][0].equals(board[i][1]) && board[i][1].equals(board[i][2]) && !board[i][0].isEmpty()) ||
                    (board[0][i].equals(board[1][i]) && board[1][i].equals(board[2][i]) && !board[0][i].isEmpty())) {
                return true;
            }
        }

        if ((board[0][0].equals(board[1][1]) && board[1][1].equals(board[2][2]) && !board[0][0].isEmpty()) ||
                (board[0][2].equals(board[1][1]) && board[1][1].equals(board[2][0]) && !board[0][2].isEmpty())) {
            return true;
        }

        return false;
    }
}
