

import org.example.GamePage;
import org.junit.jupiter.api.*;
import org.openqa.selenium.*;
import org.openqa.selenium.chrome.ChromeDriver;

import java.io.IOException;

public class TicTacToeTest {
    private WebDriver driver;
    private GamePage gamePage;

    @BeforeEach
    public void setUp() {
        driver = new ChromeDriver();
        gamePage = new GamePage(driver);
        driver.get("https://www.google.com");
    }

    @Test
    public void testPlayGame() throws IOException {
        gamePage.searchGame("крестики нолики");  // Поиск игры в Google
        gamePage.selectPlayWithFriend();          // Выбор "Играть с другом"
        playGame();                               // Игра в крестики-нолики
    }

    private void playGame() throws IOException {
        int movesCount = 0;
        boolean isXTurn = true;  // Первый ход - за крестиками

        while (movesCount < 9) {
            boolean madeMove = false;
            for (int i = 1; i <= 3; i++) {
                for (int j = 1; j <= 3; j++) {
                    if (gamePage.isCellAvailable(i, j)) {
                        gamePage.makeMove(i, j);  // Совершаем ход
                        madeMove = true;
                        movesCount++;

                        // Проверяем, победил ли кто-то
                        if (gamePage.checkWinner()) {
                            if (isXTurn) {
                                System.out.println("Победил игрок X!");
                            } else {
                                System.out.println("Победил игрок O!");
                            }
                            return;
                        }

                        // Если все клетки заняты (ничья)
                        if (movesCount == 9) {
                            System.out.println("Игра закончилась вничью.");
                            return;
                        }

                        // Меняем очередь ходящего игрока
                        isXTurn = !isXTurn;
                        break;
                    }
                }
                if (madeMove) break;
            }
            if (!madeMove) break;
        }
    }

    @AfterEach
    public void tearDown() {
        if (driver != null) {
            driver.quit();
        }
    }
}

